/// <reference types="node" />
/// <reference types="node" />
import { AssetContentsReader, AssetOutputStrategy } from "..";
type Setter<T> = (arg: T | undefined) => T;
export interface AssetData {
    id: string;
    tenant: string;
    locale: string;
    key: string;
    size: number;
    contentType: string;
}
export declare class Asset {
    protected readonly props: AssetData;
    private outputStrategy;
    private contentsReader;
    constructor(props: AssetData);
    clone(): Asset;
    withProps(props: Partial<AssetData>): Asset;
    getId(): string;
    getTenant(): string;
    getLocale(): string;
    getKey(): string;
    getSize(): number;
    getContentType(): string;
    getExtension(): string;
    getContents(): Promise<Buffer>;
    setContentsReader(reader: AssetContentsReader): void;
    output(): Promise<import("..").AssetReply>;
    setOutputStrategy(setter: Setter<AssetOutputStrategy> | AssetOutputStrategy): void;
}
export {};
