"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrivateCache = void 0;
var _cacheControlParser = require("cache-control-parser");
class PrivateCache {
  constructor(strategy) {
    this.strategy = strategy;
  }
  async output(asset) {
    const reply = await this.strategy.output(asset);
    reply.setHeaders(headers => {
      headers.set("cache-control", (value = "") => {
        const cacheControl = (0, _cacheControlParser.parse)(value);
        cacheControl["private"] = true;
        cacheControl["public"] = false;
        return (0, _cacheControlParser.stringify)(cacheControl);
      });
      return headers;
    });
    return reply;
  }
}
exports.PrivateCache = PrivateCache;

//# sourceMappingURL=PrivateCache.js.map